<?php
/*
  $Id: quantum_iframe.php 1813 2008-01-13 12:53:40Z hpdl $

  Released under the GNU General Public License
  
  http://www.quantumgateway.com

  by

 Jerry Brown - CDG Commerce
  support@cdgcommerce.com
  
 2015-01-26
 Added  the following to the api. - Pre populate fields
	#Billing Information
$fname, $lname, $address, $city, $state, $zip, $country, $phone, $email, 
	#Shipping information
$sfname, $slname, $saddress, $scity, $sstate, $szip, $scountry, 
$Vendor # Please only use the Vendor if you are actually a Vendor.  Vendor would be the name of the software and it is for special useage for approved partners.
$invoice_num
$trans_type #AUTH_ONLY, AUTH_CAPTURE, SALES

#Override Processing Settings return urls 
 $post_return_url_approved, $post_return_url_declined, 
#over ride gateway sending emails
$override_trans_email, $override_email_customer

2020
Added ability for RecurringCustomerEdit
Changed the post back url var to be sent at authentication rather than in the ILF / Address.
*/
 

function _quantumilf_http_post($host, $path, $data, $port = 80) {

        $req = _quantumilf_qsencode ($data);
		$response = '';
		if ( (PHP_VERSION >= 4.3) && ($fs = @fsockopen('ssl://secure.quantumgateway.com', 443, $errno, $errstr, 30)) ) {
		
			$http_request  = "POST $path HTTP/1.0\r\n";
			$http_request .= "Host: $host\r\n";
			$http_request .= "Content-Type: application/x-www-form-urlencoded;\r\n";
			$http_request .= "Content-Length: " . strlen($req) . "\r\n";
			$agent = "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:34.0) Gecko/20100101 Firefox/34.0";
			$http_request .= "User-Agent: $agent\r\n";
			$http_request .= "\r\n";
			$http_request .= $req;
 
		    fwrite($fs, $http_request);
			while (!feof($fs)) {
				$response .= fgets($fs, 1160); // One TCP-IP packet
			}
			
    		fclose($fs);
			$response = explode("\r\n\r\n", $response, 2);
		} elseif (function_exists('curl_exec')) {
		
			 $ch = curl_init();
			$curl_url = 'https://secure.quantumgateway.com' . $path;
			curl_setopt($ch, CURLOPT_URL, $curl_url);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_HEADER, false);
			curl_setopt($ch, CURLOPT_TIMEOUT, 30);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_SSLVERSION, 6); 
		
			$result = curl_exec($ch);
			$response = explode("\r\n\r\n", $result, 2);
			$response[1] = $response[0];
			curl_close($ch);
			
			
		} 
        return $response;
}

function _quantumilf_qsencode ($data) {
        $req = "";
        foreach ( $data as $key => $value )
                $req .= $key . '=' . urlencode( stripslashes($value) ) . '&';

        // Cut the last '&'
        $req=substr($req,0,strlen($req)-1);
        return $req;
}



function quantumilf_getCode($API_Username, $API_Key, $width, $height, $amount='0', $id='0', $custid='0', $method='0', $addtoVault='N', $skipshipping='N', $fname, $lname, $address, $city, $state, $zip, $country, $phone, $email, $invoice_num, $sfname, $slname, $saddress, $scity, $sstate, $szip, $scountry, $trans_type, $post_return_url_approved, $post_return_url_declined, $Vendor, $override_trans_email, $override_email_customer, $RID='0', $recur_times, $OverRideRecureDay, $override_recur, $PayInfoOnly, $name_on_card, $item_description, $skip_shipping_info, $Require_FNAME, $Require_LNAME, $Require_phone, $Require_BCITY, $Require_BSTATE, $Require_BADDR1, $Require_BZIP1, $Require_BCOUNTRY, $Require_CVV2, $RecurrID=0, $post_back_url='') {
	$thereturn = array();
	$random = rand(1111111111, 9999999999);
	$random = (int)$random;
	$response = _quantumilf_http_post("secure.quantumgateway.com", "/cgi/ilf_authenticate.php",
                                          array (
                                                 'API_Username' => $API_Username,
                                                 'API_Key' => $API_Key,
                                                 'randval' => $random,
												 'lastip' => $_SERVER['REMOTE_ADDR'],
												 'post_back_url' => $post_back_url,
												 'post_return_url_approved' => $post_return_url_approved,
												 'post_return_url_declined' => $post_return_url_declined
                                                 ), 443
                                          );
										  
					print_r($response, 1);					  
										  
								  
	if (is_array($response)) {
		if ($response[1] != 'error') {
			$extrapars = '';
			if ($method != '0') {
				$extrapars .= "&METHOD=$method";	
			}
			if ($addtoVault == 'Y') {
				$extrapars .= "&AddToVault=Y";				
			}
			if ($skipshipping == 'Y') {
				$extrapars .= "&skip_shipping_info=Y";				
			}
			if ($custid != '0') {
				$extrapars .= "&CustomerID=" . urlencode($custid);				
			}
			if ($amount > '0')	{
				$extrapars .= "&Amount=$amount";
			}
			if ($id > '0')	{
				$extrapars .= "&ID=" .$id;
			}
			#$extrapars .= "&skip_shipping_info=Y&ilf_API_Style=2"; 
			#custom/advanced
			if(!$fname || $fname=='') {} else {
			$extrapars .= "&FNAME=$fname";	
			}
			if(!$lname || $lname=='') {} else {
			$extrapars .= "&LNAME=$lname";	
			}
			if(!$address || $address=='') {} else {
			$extrapars .= "&BADDR1=$address";	
			}
			if(!$city || $city=='') {} else {
			$extrapars .= "&BCITY=$city";	
			}
			if(!$state || $state=='') {} else {
			$extrapars .= "&BSTATE=$state";	
			}
			if(!$zip || $zip=='') {} else {
			$extrapars .= "&BZIP1=$zip";	
			}
			if(!$country || $country=='') {} else {
			$extrapars .= "&BCOUNTRY=$country";	
			}
			if(!$phone || $phone=='') {} else {
			$extrapars .= "&phone=$phone";	
			}
			if(!$email || $email=='') {} else {
			$extrapars .= "&BCUST_EMAIL=$email";	
			}
			if(!$invoice_num || $invoice_num=='') {} else {
			$extrapars .= "&invoice_num=$invoice_num";	
			}
			
			if(!$sfname || $sfname=='') {} else {
			$extrapars .= "&SFNAME=$sfname";	
			}
			if(!$slname || $slname=='') {} else {
			$extrapars .= "&SLNAME=$slname";	
			}
			if(!$saddress || $saddress=='') {} else {
			$extrapars .= "&SADDR1=$saddress";	
			}
			if(!$scity || $scity=='') {} else {
			$extrapars .= "&SCITY=$scity";	
			}
			if(!$sstate || $sstate=='') {} else {
			$extrapars .= "&SSTATE=$sstate";	
			}
			if(!$szip || $szip=='') {} else {
			$extrapars .= "&SZIP1=$szip";	
			}
			if(!$scountry || $scountry=='') {} else {
			$extrapars .= "&SCOUNTRY=$scountry";	
			}
			if(!$trans_type || $trans_type) {} else {
				if($trans_type=='AUTH_ONLY' || $trans_type=='AUTH_CAPTURE' || $trans_type=='SALES') {
			$extrapars .= "&trans_type=$trans_type";	
			}
			}
			if(!$Vendor || $Vendor=='') {} else {
			$extrapars .= "&Vendor=$Vendor";	
			}
			
				if($override_trans_email=='Y' || $override_trans_email=='N') {
			$extrapars .= "&override_trans_email$override_trans_email";	
			}
			
			if($override_email_customer=='Y' || $override_email_customer=='N') {
			$extrapars .= "&override_email_customer=$override_email_customer";	
			}

			
			if($RID>0) {
			$extrapars .= "&RID=$RID";	
			}
			
			if($OverRideRecureDay=='Y') {
			$extrapars .= "&OverRideRecureDay=$OverRideRecureDay";	
			}

			
			if($override_recur=='Y') {
			$extrapars .= "&override_recur=$override_recur";	
			}

			
			if($recur_times>0) {
			$extrapars .= "&recur_times=$recur_times";	
			}
			

			if($PayInfoOnly=='Y') {
			$extrapars .= "&PayInfoOnly=Y";	
			}


			if(!$name_on_card || $name_on_card=='') {} else {
			$extrapars .= "&name_on_card=$name_on_card";	
			}	
			
			if(!$item_description || $item_description=='') {} else {
			$extrapars .= "&item_description=$item_description";	
			}
			
			if($skip_shipping_info=='Y') {
			$extrapars .= "&skip_shipping_info=Y";	
			}
			
			if($Require_FNAME=='Y') {
			$extrapars .= "&Require_FNAME=Y";	
			}
			
			if($Require_LNAME=='Y') {
			$extrapars .= "&Require_LNAME=Y";	
			}
			
			if($Require_phone=='Y') {
			$extrapars .= "&Require_phone=Y";	
			}
			
			if($Require_BCITY=='Y') {
			$extrapars .= "&Require_BCITY=Y";	
			}
			
			if($Require_BSTATE=='Y') {
			$extrapars .= "&Require_BSTATE=Y";	
			}
			
			if($Require_BADDR1=='Y') {
			$extrapars .= "&Require_BADDR1=Y";	
			}
			
			if($Require_BZIP1=='Y') {
			$extrapars .= "&Require_BZIP1=Y";	
			}
			
			if($Require_BCOUNTRY=='Y') {
			$extrapars .= "&Require_BCOUNTRY=Y";	
			}
			
			if($Require_CVV2=='Y') {
			$extrapars .= "&Require_CVV2=Y";	
			}						
			
			
			$thereturn['iframe'] = '<iframe src="https://secure.quantumgateway.com/cgi/ilf.php?k=' . $response[1] . '&ip=' . $_SERVER['REMOTE_ADDR'] . $extrapars . '" height="' . $height . '" width="' . $width . '" frameborder="0"></iframe><br/>';	
			$thereturn['script']  = '<script src="https://secure.quantumgateway.com/javascript/prototype.js" type="text/javascript"></script>
<script type="text/javascript">
function refreshSession(thek, theip) {
	var randomnumber=Math.random();
	var tposturl = "quantum_iframe.php?cachebuster=" + randomnumber;
	var thequerystring = "ajax=true&ip=" + theip + "&k=" + thek;
	var thecheck = new Ajax.Request(tposturl, {	method: "post", parameters: thequerystring });
	
}
setInterval("refreshSession(\'' . $response[1] . '\',\'' . $_SERVER['REMOTE_ADDR'] . '\')",20000);
</script>
';
		}
	}
	return $thereturn;
}
if (isset($_POST['ajax']))  {
	if ($_POST['ajax'] == "true") {
	$response = _quantumilf_http_post("secure.quantumgateway.com", "/cgi/ilf_refresh.php",
									  array (
											 'ip' => $_POST['ip'],
											 'k' => $_POST['k']
											 ), 443
									  );
	}	
}
?>